//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern int             ChannelPeriod   = 9;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = true;
extern bool            alertsEmail     = true;
extern bool            alertsPush      = false;
extern bool            Interpolate     = true;

extern bool            ShowLine        = true; 
 
//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      if(ShowLine)
      {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
      SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
      SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
      }
      SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
      SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      // 
      //
      //
      
      IndicatorShortName(timeFrameToString(TimeFrame)+" Donchian Channel Stop");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { UpLine[0] = limit+1; return(0); } 
            
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {  
     for(i=limit; i>=0; i--)
     { 
       if (High[i] > smax[i+1])
             smax[i] =  High[i];
       else  smax[i] = (High[iHighest(NULL,0,MODE_HIGH,ChannelPeriod,i)]+smax[i+1])/2.0;
          
       if (Low[i] < smin[i+1])
             smin[i] =  Low[i];
       else  smin[i] = (Low[iLowest(NULL,0,MODE_LOW,ChannelPeriod,i)]+smin[i+1])/2.0; 
          
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (Close[i]>smax[i+1]) trend[i]= 1; 
	      if (Close[i]<smin[i+1]) trend[i]=-1;
	      if (trend[i]>0 && smin[i]<smin[i+1]) smin[i]=smin[i+1];
	      if (trend[i]<0 && smax[i]>smax[i+1]) smax[i]=smax[i+1];
         if (trend[i] == 1) {  UpLine[i] = smin[i]; if (trend[i+1]!= 1) UpArrow[i] = UpLine[i]; }
         if (trend[i] ==-1) {  DnLine[i] = smax[i]; if (trend[i+1]!=-1) DnArrow[i] = DnLine[i]; }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1)   doAlert(whichBar,"up");
            if (trend[whichBar] ==-1)   doAlert(whichBar,"down");
         }         
      }
      return(0);
      }
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for(i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,0,y);
         DnLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,1,y);
         trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,7,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;

         if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
         if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               if (UpLine[i]!= EMPTY_VALUE && UpLine[i+n]!= EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n] - UpLine[i]) * k/n;
               if (DnLine[i]!= EMPTY_VALUE && DnLine[i+n]!= EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n] - DnLine[i]) * k/n;
            }
   } 
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Donchian Channel Stop ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsPush)    SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Donchian Channel Stop "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

